/*
Copyright (c) 2002-2011 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/

#ifndef __SIMP_H
#define __SIMP_H

/*==========================================
   S60 SimpleEx Header File
==========================================*/

#include <eikenv.h>

#include <eikon.hrh>
#include "SimpleEx.hrh"

#include <akndoc.h>
#include <aknapp.h>
#include <aknappui.h>
#include "SimpleExUid.h"

#include "weatherinfo.h"

const TUid KUidSimpleExApp = {SIMPLEEXUID};

// The Application Class 

class CSimpleExApplication : public CAknApplication
	{
private: 
    CApaDocument* CreateDocumentL();
    TUid AppDllUid() const;
	};

// The Application View Class 

class CSimpleExAppView : public CCoeControl
    {
public:
    static CSimpleExAppView* NewL(const TRect& aRect);
    static CSimpleExAppView* CSimpleExAppView::NewLC(const TRect& aRect);
    void ConstructL(const TRect& aRect);
private:
    void Draw(const TRect&) const;
    };

// The UI Class

class CSimpleExAppUi : public CAknAppUi, public MWeatherObserver
    {
public:
    void ConstructL();
    ~CSimpleExAppUi();
// from MWeatherObserver
	virtual void TemperatureReport(TDesC& aCity, TDesC& aTemperature);
	virtual void TemperatureError(TDesC& aErrorStr,TInt aErrCode);
private:
    void HandleCommandL(TInt aCommand);
    CSimpleExAppView* iAppView;
    CWeatherInfo *iWeather;
    };


// The Application Document Class
 
class CSimpleExDocument : public CAknDocument
    {
public:
    CSimpleExDocument(CEikApplication& aApp): CAknDocument(aApp) { }
private: 
    CEikAppUi* CreateAppUiL();
    };

#endif
